


#ifndef __CH57x_USBHOST_H__
#define __CH57x_USBHOST_H__

#ifdef __cplusplus
 extern "C" {
#endif

#include "CH579SFR.h"
#include "core_cm0.h"

/***************************************** ʹUļϵͳU̹USBhub棬Ҫر涨 */
#define	FOR_ROOT_UDISK_ONLY
/***************************************** ʹUļϵͳ⣬Ҫ涨, ʹر */
#define DISK_BASE_BUF_LEN		512	        /* ĬϵĴݻСΪ512ֽ,ѡΪ20484096֧ĳЩU,Ϊ0ֹ.Hļж建ӦópDISK_BASE_BUFָ */
    
     
     
// ӳ򷵻״̬
#define ERR_SUCCESS         0x00    // ɹ
#define ERR_USB_CONNECT     0x15    /* ⵽USB豸¼,Ѿ */
#define ERR_USB_DISCON      0x16    /* ⵽USB豸Ͽ¼,ѾϿ */
#define ERR_USB_BUF_OVER    0x17    /* USB̫໺ */
#define ERR_USB_DISK_ERR    0x1F    /* USB洢ʧ,ڳʼʱUSB洢֧,ڶдпǴ𻵻ѾϿ */
#define ERR_USB_TRANSFER    0x20    /* NAK/STALLȸ0x20~0x2F */
#define ERR_USB_UNSUPPORT   0xFB    /*ֵ֧USB豸*/
#define ERR_USB_UNKNOWN     0xFE    /*豸*/ 
#define ERR_AOA_PROTOCOL    0x41    /*Э汾 */ 

/*USB豸Ϣ,֧1豸*/
#define ROOT_DEV_DISCONNECT  0
#define ROOT_DEV_CONNECTED   1
#define ROOT_DEV_FAILED      2
#define ROOT_DEV_SUCCESS     3
#define DEV_TYPE_KEYBOARD   ( USB_DEV_CLASS_HID | 0x20 )
#define DEV_TYPE_MOUSE      ( USB_DEV_CLASS_HID | 0x30 )
#define DEF_AOA_DEVICE       0xF0
#define DEV_TYPE_UNKNOW 	 0xFF


/*
Լ: USB豸ַ(οUSB_DEVICE_ADDR)
ֵַ  豸λ
0x02    Root-HUBµUSB豸ⲿHUB
0x1x    Root-HUBµⲿHUBĶ˿xµUSB豸,xΪ1~n
*/
#define HUB_MAX_PORTS       	4
#define WAIT_USB_TOUT_200US     800   // ȴUSBжϳʱʱ


typedef struct
{
    UINT8   DeviceStatus;              // 豸״̬,0-豸,1-豸δʼ,2-豸ʼöʧ,3-豸ҳʼöٳɹ
    UINT8   DeviceAddress;             // 豸USBַ
    UINT8   DeviceSpeed;               // 0Ϊ,0Ϊȫ
    UINT8   DeviceType;                // 豸
    UINT16  DeviceVID;
    UINT16  DevicePID;
    UINT8   GpVar[4];                    // ͨñŶ˵
    UINT8   GpHUBPortNum;                // ͨñ,HUBʾHUB˿
} _RootHubDev;


extern _RootHubDev  ThisUsbDev;
extern UINT8  UsbDevEndp0Size;              // USB豸Ķ˵0ߴ */
extern UINT8  FoundNewDev;

extern PUINT8  pHOST_RX_RAM_Addr;
extern PUINT8  pHOST_TX_RAM_Addr;
#define pSetupReq   ((PUSB_SETUP_REQ)pHOST_TX_RAM_Addr)
extern UINT8  Com_Buffer[];

/* ΪUSB */
extern const UINT8  SetupGetDevDescr[];    //*ȡ豸*/
extern const UINT8  SetupGetCfgDescr[];    //*ȡ*/
extern const UINT8  SetupSetUsbAddr[];     //*USBַ*/
extern const UINT8  SetupSetUsbConfig[];   //*USB*/
extern const UINT8  SetupSetUsbInterface[];//*USBӿ*/
extern const UINT8  SetupClrEndpStall[];   //*˵STALL*/


void  DisableRootHubPort(void)  ;                   // رROOT-HUB˿,ʵӲѾԶر,˴ֻһЩṹ״̬
UINT8   AnalyzeRootHub( void ) ;         // ROOT-HUB״̬,ROOT-HUB˿ڵ豸¼
// ERR_SUCCESSΪû,ERR_USB_CONNECTΪ⵽,ERR_USB_DISCONΪ⵽Ͽ
void    SetHostUsbAddr( UINT8 addr );                 // USBǰUSB豸ַ
void    SetUsbSpeed( UINT8 FullSpeed );               // õǰUSBٶ
void    ResetRootHubPort(void);                          // ⵽豸,λӦ˿ڵ,Ϊö豸׼,ΪĬΪȫ
UINT8   EnableRootHubPort(void);                          // ʹROOT-HUB˿,ӦbUH_PORT_EN1˿,豸Ͽܵ·ʧ
void    SelectHubPort( UINT8 HubPortIndex );// HubPortIndex=0ѡָROOT-HUB˿,ѡָROOT-HUB˿ڵⲿHUBָ˿
UINT8   WaitUSB_Interrupt( void );                    // ȴUSBж
// ,ĿĶ˵ַ/PID,ͬ־,20uSΪλNAKʱ(0,0xFFFF),0ɹ,ʱ/
UINT8   USBHostTransact( UINT8 endp_pid, UINT8 tog, UINT32 timeout );  // endp_pid: 4λtoken_pid, 4λǶ˵ַ
UINT8   HostCtrlTransfer( PUINT8 DataBuf, PUINT8 RetLen );  // ִпƴ,8ֽpSetupReq,DataBufΪѡշ
// Ҫպͷ,ôDataBufָЧڴź,ʵʳɹշܳȷرReqLenָֽڱ


void CopySetupReqPkg( PCCHAR pReqPkt );            // ƿƴ
UINT8 CtrlGetDeviceDescr( void );                    // ȡ豸, pHOST_TX_RAM_Addr 
UINT8 CtrlGetConfigDescr( void );                    // ȡ, pHOST_TX_RAM_Addr 
UINT8 CtrlSetUsbAddress( UINT8 addr );                         // USB豸ַ
UINT8 CtrlSetUsbConfig( UINT8 cfg );                           // USB豸
UINT8 CtrlClearEndpStall( UINT8 endp ) ;                       // ˵STALL
UINT8 CtrlSetUsbIntercace( UINT8 cfg );					       // USB豸ӿ


void    USB_HostInit( void );                                  // ʼUSB



/*************************************************************/


UINT8 InitRootDevice( void ); 

UINT8   CtrlGetHIDDeviceReport( UINT8 infc );          // HIDSET_IDLEGET_REPORT 
UINT8   CtrlGetHubDescr( void );                       // ȡHUB,TxBuffer
UINT8   HubGetPortStatus( UINT8 HubPortIndex );        // ѯHUB˿״̬,TxBuffer
UINT8   HubSetPortFeature( UINT8 HubPortIndex, UINT8 FeatureSelt );  // HUB˿
UINT8   HubClearPortFeature( UINT8 HubPortIndex, UINT8 FeatureSelt );  // HUB˿
	 	 
	 
	 
#ifdef __cplusplus
}
#endif

#endif  // __CH57x_USBHOST_H__	

