#include <stdio.h>
#include <string.h>
#include "CH57x_common.h"
#include "core_cm0.h"
#include "CH57xNET.H"

#define KEEPLIVE_ENABLE                      1                                  /* KEEPLIVE */

/* ĻȫֱҪ壬е */
__align(16)UINT8    CH57xMACRxDesBuf[(RX_QUEUE_ENTRIES )*16];                   /* MAC16ֽڶ */
__align(4) UINT8    CH57xMACRxBuf[RX_QUEUE_ENTRIES*RX_BUF_SIZE];                /* MACջ4ֽڶ */
__align(4) SOCK_INF SocketInf[CH57xNET_MAX_SOCKET_NUM];                         /* SocketϢ4ֽڶ */

UINT16 MemNum[8] = {CH57xNET_NUM_IPRAW,
                    CH57xNET_NUM_UDP,
                    CH57xNET_NUM_TCP,
                    CH57xNET_NUM_TCP_LISTEN,
                    CH57xNET_NUM_TCP_SEG,
                    CH57xNET_NUM_IP_REASSDATA,
                    CH57xNET_NUM_PBUF,
                    CH57xNET_NUM_POOL_BUF
                    };
UINT16 MemSize[8] = {CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_IPRAW_PCB),
                    CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_UDP_PCB),
                    CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_TCP_PCB),
                    CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_TCP_PCB_LISTEN),
                    CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_TCP_SEG),
                    CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_IP_REASSDATA),
                    CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_PBUF) + CH57xNET_MEM_ALIGN_SIZE(0),
                    CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_PBUF) + CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_POOL_BUF)
                    };
__align(4)UINT8 Memp_Memory[CH57xNET_MEMP_SIZE];
__align(4)UINT8 Mem_Heap_Memory[CH57xNET_RAM_HEAP_SIZE];
__align(4)UINT8 Mem_ArpTable[CH57xNET_RAM_ARP_TABLE_SIZE];

										
#define RECE_BUF_LEN                          536                               /* ջĴС */
 
																				
/* CH579ض */
UINT8 MACAddr[6]= {0x84,0xc2,0xe4,0x02,0x03,0x04};                              /* CH579MACַ */
UINT8 IPAddr[4] = {192,168,1,200};                                              /* CH579IPַ */
UINT8 GWIPAddr[4]={192,168,1,1};                                                /* CH579 */
UINT8 IPMask[4] = {255,255,255,0};                                              /* CH579 */

/* ڵƶ PBڵʮλЧ */
UINT16 CH57xNET_LEDCONN=0x0020;                                                 /* ָʾ PB4 */
UINT16 CH57xNET_LEDDATA=0x0080;                                                 /* ͨѶָʾ PB7 */ 

UINT8 SocketId;                                                                 /* socketԲö */
UINT8 SocketRecvBuf[4][RECE_BUF_LEN];                                              /* socketջ */
UINT8 MyBuf[RECE_BUF_LEN];                                                      /* һʱ */


#define	RUN0	GPIOB_ResetBits(GPIO_Pin_6)
#define	RUN1	GPIOB_SetBits(GPIO_Pin_6)
#define	ACK0	GPIOB_ResetBits(GPIO_Pin_7)
#define	ACK1	GPIOB_SetBits(GPIO_Pin_7)

#define	DIR0	GPIOB_ResetBits(GPIO_Pin_1)
#define	DIR1	GPIOB_SetBits(GPIO_Pin_1)
#define	STOP0	GPIOB_ResetBits(GPIO_Pin_3)
#define	STOP1	GPIOB_SetBits(GPIO_Pin_3)

UINT32 rin=0,slen=0;
UINT8 mysockeid=0,rbuf[256],sbuf[256];

UINT8 ss=0,ss2=0,online=0;
unsigned short pl=0,ivn=0,rs485_buf[20]={0,};
unsigned int iv=0;
float fx=0.0;
signed short  ADRC=0;		// ADCֵƫֵ


void ETH_IRQHandler( void )					                             		/* ̫ж */
{
	CH57xNET_ETHIsr();							                             	/* ̫жжϷ */
}

void GPIO_IRQHandler(void)
{
  GPIOB_ClearITFlagBit(GPIO_Pin_0);
	pl++;
}


/*TMR0ж*/
void TMR0_IRQHandler( void )
{
	if( TMR0_GetITFlag( TMR0_3_IT_CYC_END ) )
	{
		
		CH57xNET_TimeIsr(CH57xNETTIMEPERIOD);                                       /* ʱжϷ */
		
		//iv+=ADC_ExcutSingleConver();	//+ADRC;
		//ivn++;

		if (ss) ss--;
		if (ss2) {
			ss2--;
			if (ss2==0) {rs485_buf[5]=fx*pl;pl=0;}
		} else ss2=20;
		
		TMR0_ClearITFlag( TMR0_3_IT_CYC_END );
	}
}
/*******************************************************************************
* Function Name  : CH57xNET_CreatTcpSocket
* Description    : TCP Client socket
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH57xNET_CreatTcpSocket(void)
{
   UINT8 i;                                                             
   SOCK_INF TmpSocketInf;                                                       /* ʱsocket */

   memset((void *)&TmpSocketInf,0,sizeof(SOCK_INF));                            /* ڲὫ˱ƣýʱȫ */
   TmpSocketInf.SourPort = 502;                                                /* Դ˿ */
   TmpSocketInf.ProtoType = PROTO_TYPE_TCP;                                     /* socekt */
   TmpSocketInf.RecvStartPoint = (UINT32)SocketRecvBuf;                         /* ýջĽջ */
   TmpSocketInf.RecvBufLen = RECE_BUF_LEN ;                                     /* ýջĽճ */
   i = CH57xNET_SocketCreat(&SocketId,&TmpSocketInf);                           /* socketصsocketSocketId */
   //mStopIfError(i);                                                             /*  */

#ifdef  KEEPLIVE_ENABLE
   CH57xNET_SocketSetKeepLive( SocketId, 1 );                                   /* socketKEEPLIVEܣV06汾֧֣ */
#endif

   i = CH57xNET_SocketListen(SocketId);                                         /* TCP */
   //mStopIfError(i);                                                             /*  */
   i = CH57xNET_SetSocketTTL( SocketId,128 );
   //mStopIfError(i);                                                             /*  */
}


/*******************************************************************************
* Function Name  : net_initkeeplive
* Description    : keepliveʼ
* Input          : None      
* Output         : None
* Return         : None
*******************************************************************************/
#ifdef  KEEPLIVE_ENABLE
void net_initkeeplive(void)
{
    struct _KEEP_CFG  klcfg;

    klcfg.KLIdle = 20000;                                                       /*  */
    klcfg.KLIntvl = 10000;                                                      /*  */
    klcfg.KLCount = 5;                                                          /*  */
    CH57xNET_ConfigKeepLive(&klcfg);
}
#endif

/*******************************************************************************
* Function Name  : CH57xNET_LibInit
* Description    : ʼ
* Input          : ip      ipַָ
*                gwip    ipַָ
*                : mask    ָ
*                : macaddr MACַָ 
* Output         : None
* Return         : ִ״̬
*******************************************************************************/
UINT8 CH57xNET_LibInit(/*const*/ UINT8 *ip,/*const*/ UINT8 *gwip,/*const*/ UINT8 *mask,/*const*/ UINT8 *macaddr)
{
    UINT8 i;
    struct _CH57x_CFG cfg;

    if(CH57xNET_GetVer() != CH57xNET_LIB_VER)return 0xfc;                       /* ȡİ汾ţǷͷļһ */
    CH57xNETConfig = LIB_CFG_VALUE;                                             /* Ϣݸñ */
    cfg.RxBufSize = RX_BUF_SIZE; 
    cfg.TCPMss   = CH57xNET_TCP_MSS;
    cfg.HeapSize = CH57x_MEM_HEAP_SIZE;
    cfg.ARPTableNum = CH57xNET_NUM_ARP_TABLE;
    cfg.MiscConfig0 = CH57xNET_MISC_CONFIG0;
    CH57xNET_ConfigLIB(&cfg);
    i = CH57xNET_Init(ip,gwip,mask,macaddr);
#ifdef  KEEPLIVE_ENABLE
    net_initkeeplive( );
#endif
    return (i);                      
}

/*******************************************************************************
* Function Name  : CH57xNET_HandleSockInt
* Description    : Socketжϴ
* Input          : sockeid  socket
*                initstat ж״̬
* Output         : None
* Return         : None
*******************************************************************************/
void CH57xNET_HandleSockInt(UINT8 sockeid,UINT8 initstat)
{
    UINT32 len;
    UINT32 totallen;
    UINT8 *p = MyBuf;

    if(initstat & SINT_STAT_RECV)                                               /* ж */
    {
        rin = CH57xNET_SocketRecvLen(sockeid,NULL);                             /* ѯ */
        CH57xNET_SocketRecv(sockeid,rbuf,&rin);                                /* ջݶMyBuf*/
				mysockeid=sockeid;
    }
    if(initstat & SINT_STAT_CONNECT)                                            /* TCPж */
    {                                                                           /* жϱʾTCPѾӣԽշ */
        //PRINT("TCP Connect Success\n");                           
        CH57xNET_ModifyRecvBuf(sockeid,(UINT32)SocketRecvBuf[sockeid],RECE_BUF_LEN);
    }
    if(initstat & SINT_STAT_DISCONNECT)                                         /* TCPϿж */
    {                                                                           /* жϣCH579ڲὫsocketΪر*/
        //PRINT("TCP Disconnect\n");                                              /* Ӧ´ */

    }
    if(initstat & SINT_STAT_TIM_OUT)                                            /* TCPʱж */
    {                                                                           /* жϣCH579ڲὫsocketΪر*/
        //PRINT("TCP Timout\n");                                                  /* Ӧ´ */

    }
}

void mysend(void) {
   UINT8 *p = sbuf;
   CH57xNET_SocketSend(mysockeid,p,&slen);    /* sbufеݷ */
}

/*******************************************************************************
* Function Name  : CH57xNET_HandleGloableInt
* Description    : ȫжϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH57xNET_HandleGlobalInt(void)
{
    UINT8 initstat;
    UINT8 i;
    UINT8 socketinit;
    initstat = CH57xNET_GetGlobalInt();                                         /* ȫж״̬ */
    if(initstat & GINT_STAT_UNREACH)                                            /* ɴж */
    {
			//PRINT("UnreachCode %d\n",CH57xInf.UnreachCode);                       /* 鿴ɴ */
        //PRINT("UnreachProto %d\n",CH57xInf.UnreachProto);                     /* 鿴ɴЭ */
        //PRINT("UnreachPort %d\n",CH57xInf.UnreachPort);                       /* ѯɴ˿ */      
    }
   if(initstat & GINT_STAT_IP_CONFLI)                                           /* IPͻж */
   {
   
   }
   if(initstat & GINT_STAT_PHY_CHANGE)                                          /* PHYıж */
   {
       i = CH57xNET_GetPHYStatus();                                             /* ȡPHY״̬ */
       //PRINT("GINT_STAT_PHY_CHANGE %02x\n",i);  
   }
   if(initstat & GINT_STAT_SOCKET)                                              /* Socketж */
   {
       for(i = 0; i < CH57xNET_MAX_SOCKET_NUM; i ++)                     
       {
           socketinit = CH57xNET_GetSocketInt(i);                               /* socketжϲ */
           if(socketinit)CH57xNET_HandleSockInt(i,socketinit);                  /* ж */
       }    
   }
}
/*******************************************************************************
* Function Name  : GetMacAddr
* Description    : ϵͳȡMACַ
* Input          : pMAC:ָ洢MacַĻ
* Output         : None
* Return         : None
*******************************************************************************/
void GetMacAddr(UINT8 *pMAC)
{
	UINT8 transbuf[6],i;
	
	GetMACAddress(transbuf);
	for(i=0;i<6;i++)
	{
		pMAC[5-i]=transbuf[i];
	
	}
}

void setcrc16(void) {
	unsigned char CRC16Hi,CRC16Lo,sh,sl,cl,ch;
	unsigned char i,j;
	
		CRC16Hi = 0xFF;
		CRC16Lo = 0xFF;
		cl=0x1;
		ch=0xa0;
	
		for (i=0;i<slen-2;i++)	{
		    CRC16Lo = CRC16Lo^ sbuf[i];
				for (j=0;j<8;j++)  {
						sh=CRC16Hi;
						sl=CRC16Lo;
						
						CRC16Hi=CRC16Hi>>1;
						CRC16Lo=CRC16Lo>>1;
					
					if (sh&0x1) CRC16Lo |=0x80;
					if (sl&0x1) {
							CRC16Hi =CRC16Hi ^ch;
							CRC16Lo =CRC16Lo ^cl;
					}
				}
		}
		sbuf[slen-2]= CRC16Lo;
		sbuf[slen-1]= CRC16Hi;
}

unsigned short checkcrc16(char l) {
	unsigned char CRC16Hi,CRC16Lo,sh,sl,cl,ch;
	unsigned char i,j;
	
		CRC16Hi = 0xFF;
		CRC16Lo = 0xFF;
		cl=0x1;
		ch=0xa0;
	
		for (i=0;i<l;i++)	{
		    CRC16Lo = CRC16Lo^ rbuf[i];
				for (j=0;j<8;j++)  {
						sh=CRC16Hi;
						sl=CRC16Lo;
						
						CRC16Hi=CRC16Hi>>1;
						CRC16Lo=CRC16Lo>>1;
					
					if (sh&0x1) CRC16Lo |=0x80;
					if (sl&0x1) {
							CRC16Hi =CRC16Hi ^ch;
							CRC16Lo =CRC16Lo ^cl;
					}
				}
		}
		return((CRC16Lo<<8)|CRC16Hi);
}

		/* д
		0=ٶȴ
		1=ɲʽ0=Ȼֹͣ1=ɲ
		2=ʱ䣬λ0.1s0=ֱ>0=
		3=ʱ䣬λ0.1s0=ֱ>0=
		
		5=ǰת λ0.01ת/
		6=ǰ
		7=״̬
		8=ǰ
		9=ǰ
		10=ٶ 0-100%
		11=ת 0=ת,1=ת
		12=ɲ 0=,1=ɲ
	
		*/

int main()
{
	unsigned char i=0,xx=0;
	unsigned short j,x1,x2,sp0=0,DO0=0x3f;
	
	PWR_UnitModCfg(ENABLE, UNIT_SYS_PLL);   // PLLϵ
	DelayMs(3); 
	SetSysClock(CLK_SOURCE_HSE_32MHz);      // ڲ PLL 32MHz 

	GPIOA_ModeCfg(GPIO_Pin_7, GPIO_ModeIN_Floating);//PA7
	GPIOA_ModeCfg(GPIO_Pin_10, GPIO_ModeIN_Floating);//PA10
	GPIOA_ModeCfg(GPIO_Pin_11, GPIO_ModeIN_Floating);//PA11
	GPIOA_ModeCfg(GPIO_Pin_12, GPIO_ModeIN_Floating);//PA12
	GPIOA_ModeCfg(GPIO_Pin_13, GPIO_ModeIN_Floating);//PA13
	GPIOA_ModeCfg(GPIO_Pin_14, GPIO_ModeIN_Floating);//PA14
	GPIOA_ModeCfg(GPIO_Pin_8, GPIO_ModeOut_PP_20mA);//PA8
	GPIOA_ModeCfg(GPIO_Pin_9, GPIO_ModeOut_PP_20mA);//PA9
	
	GPIOB_ModeCfg(GPIO_Pin_0, GPIO_ModeIN_PU);//PB0
	GPIOB_ModeCfg(GPIO_Pin_1, GPIO_ModeOut_PP_20mA);//PB1
	GPIOB_ModeCfg(GPIO_Pin_2, GPIO_ModeOut_PP_5mA); // PB2 - PWM8
	GPIOB_ModeCfg(GPIO_Pin_3, GPIO_ModeOut_PP_20mA);//PB3
	GPIOB_ModeCfg(GPIO_Pin_6, GPIO_ModeOut_PP_20mA);//PB6
	GPIOB_ModeCfg(GPIO_Pin_7, GPIO_ModeOut_PP_20mA);//PB7
	GPIOB_ModeCfg(GPIO_Pin_8, GPIO_ModeOut_PP_20mA);//PB8
	GPIOB_ModeCfg(GPIO_Pin_9, GPIO_ModeOut_PP_20mA);//PB9

	STOP1;
	
	//öʱ0,ʱʱFREQ_SYS
	TMR0_TimerInit( (FREQ_SYS/100) );   //ʱ10ms
	TMR0_ITCfg(ENABLE, TMR0_3_IT_CYC_END); //ʹܶʱж
	NVIC_SetPriority(TMR0_IRQn,18);//жȼ(ҲԲ,Ĭ3)
	NVIC_EnableIRQ( TMR0_IRQn );
	
	GPIOB_ITModeCfg( GPIO_Pin_0, GPIO_ITMode_FallEdge );        // ½ػ
	NVIC_EnableIRQ( GPIO_IRQn );

	PWMX_CLKCfg(4);                   // cycle = 4/Fsys
	PWMX_CycleCfg(PWMX_Cycle_127);     //  = 127*cycle

  PWMX_ACTOUT( CH_PWM8, 0, Low_Level, ENABLE);   
	
	//PRINT( "Start @ChipID=%02X\n",  );
	GetMacAddr(MACAddr);
	i = CH57xNET_LibInit(IPAddr,GWIPAddr,IPMask,MACAddr);                       /* ʼ */
	//mStopIfError(i);                                                            /*  */
	
	NVIC_EnableIRQ(ETH_IRQn);	
	
	//ADC_InterTSSampInit();
	
	GPIOA_ModeCfg(GPIO_Pin_4, GPIO_ModeIN_Floating);
	ADC_ExtSingleChSampInit( SampleFreq_4, ADC_PGA_0 );
  //ADRC=ADC_DataCalib_Rough();  // ڼADCڲƫ¼ȫֱ RoughCalib_Value  
	ADC_ChannelCfg(0);
	
	for (i=0;i<20;i++) rs485_buf[i]=0;
	
	rs485_buf[0]=75;			
	rs485_buf[1]=0;			
	rs485_buf[2]=0;			
	rs485_buf[3]=0;			
	rs485_buf[4]=0;
	
	//rs485_buf[6]=R8_CHIP_ID;
	
	while(1)
	{
		if (online) {
			CH57xNET_MainTask();                                                    // CH57xNETҪѭвϵ 
			if(CH57xNET_QueryGlobalInt())CH57xNET_HandleGlobalInt();                // ѯжϣжϣȫжϴ
		}

		if (ss==0) {
			ss=10;
			
      // TCP Socket
			if (online==0) {
				if ((i=CH57xInf.PHYStat)>1 )  {
					CH57xNET_CreatTcpSocket();
					online=1;
				}
			}

			if (rs485_buf[0]) fx=300.0/rs485_buf[0]; else fx=0.0;
			
			//
			//if (ivn)	rs485_buf[6]=iv/ivn;
			iv=0;ivn=0;		
			rs485_buf[6]=ADC_ExcutSingleConver();

			//DI
			rs485_buf[8]=0;
			j=GPIOA_ReadPort();
			if (j&(1<<7)) rs485_buf[8]+=0X1;
			if (j&(1<<10)) rs485_buf[8]+=0X2;
			if (j&(1<<11)) rs485_buf[8]+=0X4;
			if (j&(1<<12)) rs485_buf[8]+=0X8;
			if (j&(1<<13)) rs485_buf[8]+=0X10;
			if (j&(1<<14)) rs485_buf[8]+=0X20;
			
			//DO
			if (rs485_buf[9]&0x1) GPIOA_SetBits(GPIO_Pin_9); else GPIOA_ResetBits(GPIO_Pin_9);
			if (rs485_buf[9]&0x2) GPIOA_SetBits(GPIO_Pin_8); else GPIOA_ResetBits(GPIO_Pin_8);
			if (rs485_buf[9]&0x4) GPIOB_SetBits(GPIO_Pin_8); else GPIOB_ResetBits(GPIO_Pin_8);
			if (rs485_buf[9]&0x8) GPIOB_SetBits(GPIO_Pin_9); else GPIOB_ResetBits(GPIO_Pin_9);
			
			if (rin>7) {
					if (rbuf[0]==1) {
						x1=checkcrc16(6);
						x2=(rbuf[6]<<8)|rbuf[7];
						
						if ((x2==0)||(x1==x2)) {
								ACK1;


								if (rbuf[1]==6) {
									
									j=(rbuf[4]<<8)|rbuf[5];
									if (rbuf[3]<5) {
										rs485_buf[rbuf[3]]=j;
										//saveini();
									}
									
									if ((rbuf[3]>8)&&(rbuf[3]<13)) {
										rs485_buf[rbuf[3]]=j;
									}
								}
								
								//ȡ
								if (((rbuf[1]==3)||(rbuf[1]==4))&&(rbuf[3]+rbuf[5]<20)) {
									
									sbuf[0]=1;
									sbuf[1]=rbuf[1];
									sbuf[2]=rbuf[5]*2;
									for (i=0;i<rbuf[5];i++) {
											sbuf[3+i*2]=rs485_buf[rbuf[3]+i]>>8;
											sbuf[4+i*2]=rs485_buf[rbuf[3]+i]&0xff;
										
									}
									slen=sbuf[2]+5;
									
									setcrc16();
									
									mysend();	
								}
						}
			  	}
					rin=0;
			}
			
			//תٿ
			if (sp0!=rs485_buf[10]) {
				sp0=rs485_buf[10];
				if (sp0>127) sp0=127;
				PWMX_ACTOUT( CH_PWM8, sp0, Low_Level, ENABLE);   
			}
			
			//ת
			if (rs485_buf[11]) DIR1; else DIR0;
			
			//ɲ
			//if (rs485_buf[12]) STOP0; else STOP1;

			if (xx) 	xx--;
			if (xx==0) {
					RUN1;
					xx=10;
			} else RUN0;
		
			
		}

	}
}


