/********************************** (C) COPYRIGHT *********************************
* File Name          : CH57xNET.H
* Author             : tech9
* Version            : V1.0
* Date               : 2015/01/15
* Description        : C Define for CH57xNET.LIB
*                      Website: http://wch.cn
*                      Email:   tech@wch.cn         
**********************************************************************************/
/* ־ */



#ifndef __CH57xNET_H__
#define __CH57xNET_H__

#define CH57xNET_ETHDBG 0

/* 汾Ϣ */
#define CH57xNET_LIB_VER                      0X01                   /* 汾Ϣ */

#ifdef __cplusplus
extern "C" {
#endif

#ifndef     TRUE
#define     TRUE    1
#define     FALSE   0
#endif
#ifndef     NULL
#define     NULL    0
#endif


	
/* Socketĸ */
#ifndef CH57xNET_MAX_SOCKET_NUM
#define CH57xNET_MAX_SOCKET_NUM               4                                 /* SocketĸûãĬΪ4Socket,Ϊ32 */
#endif

#ifndef RX_QUEUE_ENTRIES
#define RX_QUEUE_ENTRIES                      4                                 /* CH57x MACУֵС2,ĬΪ7Ϊ32 */
#endif                                                                          /* #ifndef RX_QUEUE_ENTRIES */
                                                                                
#ifndef RX_BUF_SIZE
#define RX_BUF_SIZE                           600                             /* CH57x MACÿȣΪ4 */
#endif

#ifndef CH57xNET_PING_ENABLE                                                    
#define CH57xNET_PING_ENABLE                  TRUE                              /* ĬPING */
#endif                                                                          /* PINGʹ */   
                                                                                
#ifndef TCP_RETRY_COUNT                                                         
#define TCP_RETRY_COUNT                       20                                /* TCPԴλΪ5λ*/
#endif                                                                          
                                                                                
#ifndef TCP_RETRY_PERIOD                                                        
#define TCP_RETRY_PERIOD                      10                                /* TCPڣλΪ50MSλΪ5λ */
#endif                                                                          
                                                                                
#ifndef CH57xNETTIMEPERIOD                                                      
#define CH57xNETTIMEPERIOD                    10                                /* ʱڣλMs,ô500 */
#endif                                                                          
                                                                                
#define MAC_INT_TYPE_IRQ                      0                                 /* ̫ʹirqж */
#define MAC_INT_TYPE_FIQ                      1                                 /* ̫ʹfrqж */
                                                                                
#ifndef MAC_INT_TYPE                                                            
#define MAC_INT_TYPE                          MAC_INT_TYPE_IRQ                  /* Ĭ̫ʹIRQж */
#endif                                                                          
                                                                                
#ifndef SOCKET_SEND_RETRY                                                       
#define SOCKET_SEND_RETRY                     1                                 /* ĬϷ */
#endif                    

#define TX_QUEUE_ENTRIES                      2                                 /* CH57x MACΪ2 */
#define LIB_CFG_VALUE                         ((SOCKET_SEND_RETRY << 25) |\
                                              (MAC_INT_TYPE << 24) |\
                                              (TCP_RETRY_PERIOD << 19) |\
                                              (TCP_RETRY_COUNT << 14) |\
                                              (CH57xNET_PING_ENABLE << 13) |\
                                              (TX_QUEUE_ENTRIES << 9) |\
                                              (RX_QUEUE_ENTRIES << 5) |\
                                              (CH57xNET_MAX_SOCKET_NUM))
#ifndef MISCE_CFG0_TCP_SEND_COPY 
#define MISCE_CFG0_TCP_SEND_COPY              1                                 /* TCPͻ */
#endif                                                                          

#ifndef MISCE_CFG0_TCP_RECV_COPY                                                
#define MISCE_CFG0_TCP_RECV_COPY              1                                 /* TCPոŻڲʹ */
#endif                                                                          

#ifndef MISCE_CFG0_TCP_OLD_DELETE                                               
#define MISCE_CFG0_TCP_OLD_DELETE             0                                 /* ɾTCP */
#endif

/*ڴ */
#ifndef CH57xNET_NUM_IPRAW
#define CH57xNET_NUM_IPRAW                    4                                 /* IPRAWӵĸ */ 
#endif

#ifndef CH57xNET_NUM_UDP
#define CH57xNET_NUM_UDP                      4                                 /* UDPӵĸ */                                   
#endif

#ifndef CH57xNET_NUM_TCP
#define CH57xNET_NUM_TCP                      4                                 /* TCPӵĸ */ 
#endif

#ifndef CH57xNET_NUM_TCP_LISTEN
#define CH57xNET_NUM_TCP_LISTEN               4                                 /* TCPĸ */
#endif

#ifndef CH57xNET_NUM_PBUF
#define CH57xNET_NUM_PBUF                     5                                 /* PBUFṹĸ */
#endif

#ifndef CH57xNET_NUM_POOL_BUF
#define CH57xNET_NUM_POOL_BUF                 6                                /* POOL BUFĸ */
#endif

#ifndef CH57xNET_NUM_TCP_SEG
#define CH57xNET_NUM_TCP_SEG                  10                                /* tcpεĸ*/
#endif

#ifndef CH57xNET_NUM_IP_REASSDATA
#define CH57xNET_NUM_IP_REASSDATA             5                                 /* IPֶεĳ */
#endif

#ifndef CH57xNET_TCP_MSS
#define CH57xNET_TCP_MSS                      536                               /* tcp MSSĴС*/
#endif

#ifndef CH57x_MEM_HEAP_SIZE
#define CH57x_MEM_HEAP_SIZE                   4600                              /* ڴѴС */
#endif

#ifndef CH57xNET_NUM_ARP_TABLE
#define CH57xNET_NUM_ARP_TABLE                10                                /* ARPб */
#endif

#ifndef CH57xNET_MEM_ALIGNMENT
#define CH57xNET_MEM_ALIGNMENT                4                                 /* 4ֽڶ */
#endif

#ifndef CH57xNET_IP_REASS_PBUFS             
#if (CH57xNET_NUM_POOL_BUF < 32)
#define CH57xNET_IP_REASS_PBUFS               (CH57xNET_NUM_POOL_BUF - 1)       /* IPƬPBUFΪ31 */
#else
#define CH57xNET_IP_REASS_PBUFS               31       
#endif
#endif

#define CH57xNET_MISC_CONFIG0                 ((MISCE_CFG0_TCP_SEND_COPY << 0) |\
                                               (MISCE_CFG0_TCP_RECV_COPY << 1) |\
                                               (MISCE_CFG0_TCP_OLD_DELETE << 2)|\
                                               (CH57xNET_IP_REASS_PBUFS)<<3)
/* PHY ״̬ */
#define PHY_DISCONN                           (1<<0)                            /* PHYϿ */
#define PHY_10M_FLL                           (1<<1)                            /* 10Mȫ˫ */
#define PHY_10M_HALF                          (1<<2)                            /* 10M˫ */
#define PHY_100M_FLL                          (1<<3)                            /* 100Mȫ˫ */
#define PHY_100M_HALF                         (1<<4)                            /* 100M˫ */
#define PHY_AUTO                              (1<<5)                            /* PHYԶģʽCMD10H_SET_PHY */
                                                                                
/* Socket ģʽ,Э */                                                       
#define PROTO_TYPE_IP_RAW                     0                                 /* IPԭʼ */
#define PROTO_TYPE_UDP                        2                                 /* UDPЭ */
#define PROTO_TYPE_TCP                        3                                 /* TCPЭ */
                                                                                
/* ж״̬ */                                                                  
/* ΪGLOB_INT״̬ */                                                
#define GINT_STAT_UNREACH                     (1<<0)                            /* ɴж*/
#define GINT_STAT_IP_CONFLI                   (1<<1)                            /* IPͻ*/
#define GINT_STAT_PHY_CHANGE                  (1<<2)                            /* PHY״̬ı */
#define GINT_STAT_SOCKET                      (1<<4)                            /* scoket ж */
                                                                                
/*ΪSn_INT״̬*/                                                    
#define SINT_STAT_RECV                        (1<<2)                            /* socket˿ڽյݻ߽ջΪ */
#define SINT_STAT_CONNECT                     (1<<3)                            /* ӳɹ,TCPģʽ²ж */
#define SINT_STAT_DISCONNECT                  (1<<4)                            /* ӶϿ,TCPģʽ²ж */
#define SINT_STAT_TIM_OUT                     (1<<6)                            /* ARPTCPģʽ»ᷢж */

/*  */
#define CH57xNET_ERR_SUCCESS                  0x00                              /* ɹ */
#define CH57xNET_RET_ABORT                    0x5F                              /* ʧ */
#define CH57xNET_ERR_BUSY                     0x10                              /* æ״̬ʾǰִ */
#define CH57xNET_ERR_MEM                      0x11                              /* ڴ */
#define CH57xNET_ERR_BUF                      0x12                              /*  */
#define CH57xNET_ERR_TIMEOUT                  0x13                              /* ʱ */
#define CH57xNET_ERR_RTE                      0x14                              /* ·ɴ*/
#define CH57xNET_ERR_ABRT                     0x15                              /* ֹͣ*/
#define CH57xNET_ERR_RST                      0x16                              /* Ӹλ */
#define CH57xNET_ERR_CLSD                     0x17                              /* ӹر/socket ڹر״̬*/
#define CH57xNET_ERR_CONN                     0x18                              /*  */
#define CH57xNET_ERR_VAL                      0x19                              /* ֵ */
#define CH57xNET_ERR_ARG                      0x1a                              /* Ĳ */
#define CH57xNET_ERR_USE                      0x1b                              /* Ѿʹ */
#define CH57xNET_ERR_IF                       0x1c                              /* MAC  */
#define CH57xNET_ERR_ISCONN                   0x1d                              /*  */
#define CH57xNET_ERR_SOCKET_MEM               0X20                              /* SocketϢбߴ */
#define CH57xNET_ERR_UNSUPPORT_PROTO          0X21                              /* ֵ֧Э */
#define CH57xNET_ERR_UNKNOW                   0xFA                              /* δ֪ */

/* ɴ */
#define UNREACH_CODE_HOST                     0                                 /* ɴ */
#define UNREACH_CODE_NET                      1                                 /* 粻ɴ */
#define UNREACH_CODE_PROTOCOL                 2                                 /* Э鲻ɴ */
#define UNREACH_CODE_PROT                     3                                 /* ˿ڲɴ */
/*ֵοRFC792ĵ*/                                                      

/* TCPرղ */
#define TCP_CLOSE_NORMAL                      0                                 /* رգ4 */
#define TCP_CLOSE_RST                         1                                 /* λӣر  */
#define TCP_CLOSE_ABANDON                     2                                 /* CH57xNETڲӣᷢκֹ */

/* socket״̬ */
#define  SOCK_STAT_CLOSED                     0X00                              /* socketر */
#define  SOCK_STAT_OPEN                       0X05                              /* socket */

/* TCP״̬ */
#define TCP_CLOSED                            0                                 /* TCP */
#define TCP_LISTEN                            1                                 /* TCPر */
#define TCP_SYN_SENT                          2                                 /* SYNͣ */
#define TCP_SYN_RCVD                          3                                 /* SYNգյ */
#define TCP_ESTABLISHED                       4                                 /* TCPӽ */
#define TCP_FIN_WAIT_1                        5                                 /* WAIT_1״̬ */
#define TCP_FIN_WAIT_2                        6                                 /* WAIT_2״̬ */
#define TCP_CLOSE_WAIT                        7                                 /* ȴر */
#define TCP_CLOSING                           8                                 /* ڹر */
#define TCP_LAST_ACK                          9                                 /* LAST_ACK*/
#define TCP_TIME_WAIT                         10                                /* 2MSLȴ */

/* sokcetϢ */
#ifndef ST_SCOK_INF
#define ST_SCOK_INF
typedef struct _SCOK_INF
{
    UINT32 IntStatus;                                                           /* ж״̬ */
    UINT32 SockIndex;                                                           /* Socketֵ */
    UINT32 RecvStartPoint;                                                      /* ջĿʼָ */
    UINT32 RecvBufLen;                                                          /* ջ */
    UINT32 RecvCurPoint;                                                        /* ջĵǰָ */
    UINT32 RecvReadPoint;                                                       /* ջĶָ */
    UINT32 RecvRemLen;                                                          /* ջʣ೤ */
    UINT32 ProtoType;                                                           /* Э */
    UINT32 ScokStatus;                                                          /* ֽSocket״̬εֽΪTCP״̬TCPģʽ */
    UINT32 DesPort;                                                             /* ĿĶ˿ */
    UINT32 SourPort;                                                            /* Դ˿IPRAWģʽΪЭ */
    UINT8  IPAddr[4];                                                           /* SocketĿIPַ 32bit*/
    void *Resv1;                                                                /* ڲʹãڱPCB */
    void *Resv2;                                                                /* ڲʹãTCP Serverʹ */
 // void (*RecvCallBack)(struct _SCOK_INF *socinf,UINT32 ipaddr,UINT16 port,UINT8 *buf,UINT32 len); /* ջص*/
    void (*AppCallBack)(struct _SCOK_INF *,UINT32 ,UINT16 ,UINT8 *,UINT32 ); /* ջص*/

}SOCK_INF;
#endif


/* CH57xȫϢ */
#ifndef ST_CH57x_SYS
#define ST_CH57x_SYS
struct _CH57x_SYS
{
    UINT8  IPAddr[4];                                                           /* CH57xIPַ 32bit */
    UINT8  GWIPAddr[4];                                                         /* CH57xصַ 32bit */
    UINT8  MASKAddr[4];                                                         /* CH57x 32bit */
    UINT8  MacAddr[8];                                                          /* CH57xMACַ 48bit */
    UINT8  UnreachIPAddr[4];                                                    /* ɵIP */
    UINT32 RetranCount;                                                         /* Դ ĬΪ10 */
    UINT32 RetranPeriod;                                                        /* ,λMS,Ĭ200MS */
    UINT32 PHYStat;                                                             /* CH57xPHY״̬ 8bit */
    UINT32 CH57xStat;                                                           /* CH57x״̬ Ƿ򿪵 */ 
    UINT32 MackFilt;                                                            /* CH57x MACˣĬΪչ㲥ձMAC 8bit */
    UINT32 GlobIntStatus;                                                       /* ȫж */
    UINT32 UnreachCode;                                                         /* ɴ */
    UINT32 UnreachProto;                                                        /* ɴЭ */
    UINT32 UnreachPort;                                                         /* ɵ˿ */
    UINT32 SendFlag;
};
#endif

/* ڴԼ */
#ifndef ST_CH57x_CFG
#define ST_CH57x_CFG
struct _CH57x_CFG
{
    UINT32 RxBufSize;                                                            /* MACջС */
    UINT32 TCPMss;                                                               /* TCP MSSС */
    UINT32 HeapSize;                                                             /* ѷڴС */
    UINT32 ARPTableNum;                                                          /* ARPб */
    UINT32 MiscConfig0;                                                          /*  */
};
#endif

/* KEEP LIVEýṹ */
#ifndef ST_KEEP_CFG
#define ST_KEEP_CFG
struct _KEEP_CFG
{
   UINT32 KLIdle;                                                               /* KEEPLIVEʱ */
   UINT32 KLIntvl;                                                              /* KEEPLIVE */
   UINT32 KLCount;                                                              /* KEEPLIVE */
};
#endif

/* ڲ */
extern UINT8  CH57xIPIntStatus;                                                 /* ж״̬ */
extern struct _CH57x_SYS   CH57xInf;                                            /* ϵͳϢб */
extern UINT32 CH57xNETConfig;                                                   /* ã˵ */
/* λ0-4 Socketĸ,ֵΪ31 */
/* λ5-8 MAC ĸֵΪ15 */
/* λ13 PINGʹܣ1ΪPING0ΪرPINGĬΪ */
/* λ14-18 TCPԴ*/
/* λ19-23 TCPڣλΪ50*/
/* λ24 ̫ж */
/* λ25  */

/* ֵΪ̶ֵԸ */
#define CH57xNET_MEM_ALIGN_SIZE(size)         (((size) + CH57xNET_MEM_ALIGNMENT - 1) & ~(CH57xNET_MEM_ALIGNMENT-1))
#define CH57xNET_SIZE_IPRAW_PCB               0x1C                              /* IPRAW PCBС */
#define CH57xNET_SIZE_UDP_PCB                 0x20                              /* UDP PCBС */
#define CH57xNET_SIZE_TCP_PCB                 0xAC                              /* TCP PCBС */
#define CH57xNET_SIZE_TCP_PCB_LISTEN          0x20                              /* TCP LISTEN PCBС */
#define CH57xNET_SIZE_IP_REASSDATA            0x20                              /* IPƬ  */
#define CH57xNET_SIZE_PBUF                    0x10                              /* Packet Buf */
#define CH57xNET_SIZE_TCP_SEG                 0x14                              /* TCP SEGṹ */
#define CH57xNET_SIZE_MEM                     0x06                              /* sizeof(struct mem) */
#define CH57xNET_SIZE_ARP_TABLE               0x10                              /* sizeof arp table */

#define CH57xNET_SIZE_POOL_BUF                CH57xNET_MEM_ALIGN_SIZE(CH57xNET_TCP_MSS + 40 +14) /* pbufشС */
#define CH57xNET_MEMP_SIZE                    ((CH57xNET_MEM_ALIGNMENT - 1) + \
                                              (CH57xNET_NUM_IPRAW * CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_IPRAW_PCB)) + \
                                              (CH57xNET_NUM_UDP * CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_UDP_PCB)) + \
                                              (CH57xNET_NUM_TCP * CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_TCP_PCB)) + \
                                              (CH57xNET_NUM_TCP_LISTEN * CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_TCP_PCB_LISTEN)) + \
                                              (CH57xNET_NUM_TCP_SEG * CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_TCP_SEG)) + \
                                              (CH57xNET_NUM_IP_REASSDATA * CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_IP_REASSDATA)) + \
                                              (CH57xNET_NUM_PBUF * (CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_PBUF) + CH57xNET_MEM_ALIGN_SIZE(0))) + \
                                              (CH57xNET_NUM_POOL_BUF * (CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_PBUF) + CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_POOL_BUF))))                    


#define  HEAP_MEM_ALIGN_SIZE                  (CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_MEM))
#define  CH57xNET_RAM_HEAP_SIZE               (CH57x_MEM_HEAP_SIZE + (2 * HEAP_MEM_ALIGN_SIZE) + CH57xNET_MEM_ALIGNMENT)
#define  CH57xNET_RAM_ARP_TABLE_SIZE          (CH57xNET_SIZE_ARP_TABLE * CH57xNET_NUM_ARP_TABLE)
/* DNSṹص */
typedef void (*dns_callback)(const char *name, UINT8 *ipaddr, void *callback_arg);

/*  */
/* CH57xNET_NUM_IPRAWǷС1 */
#if(CH57xNET_NUM_IPRAW < 1)
#error "CH57xNET_NUM_IPRAW Error,Please Config CH57xNET_NUM_IPRAW >= 1"
#endif
/* CH57xNET_SIZE_UDP_PCBǷС1 */
#if(CH57xNET_SIZE_UDP_PCB < 1)
#error "CH57xNET_SIZE_UDP_PCB Error,Please Config CH57xNET_SIZE_UDP_PCB >= 1"
#endif
/* CH57xNET_NUM_TCPǷС1 */
#if(CH57xNET_NUM_TCP < 1)
#error "CH57xNET_NUM_TCP Error,Please Config CH57xNET_NUM_TCP >= 1"
#endif
/* CH57xNET_NUM_TCP_LISTENǷС1 */
#if(CH57xNET_NUM_TCP_LISTEN < 1)
#error "CH57xNET_NUM_TCP_LISTEN Error,Please Config CH57xNET_NUM_TCP_LISTEN >= 1"
#endif
/* ֽڶΪ4 */
#if((CH57xNET_MEM_ALIGNMENT % 4) || (CH57xNET_MEM_ALIGNMENT == 0))
#error "CH57xNET_MEM_ALIGNMENT Error,Please Config CH57xNET_MEM_ALIGNMENT = 4 * N, N >=1"
#endif
/* TCPĶγ */
#if((CH57xNET_TCP_MSS > 1460) || (CH57xNET_TCP_MSS < 60))
#error "CH57xNET_TCP_MSS Error,Please Config CH57xNET_TCP_MSS >= 60 && CH57xNET_TCP_MSS <= 1460"
#endif
/* ARP */
#if((CH57xNET_NUM_ARP_TABLE > 0X7F) || (CH57xNET_NUM_ARP_TABLE < 1))
#error "CH57xNET_NUM_ARP_TABLE Error,Please Config CH57xNET_NUM_ARP_TABLE >= 1 && CH57xNET_NUM_ARP_TABLE <= 0X7F"
#endif
/* POOL BUF */
#if(CH57xNET_NUM_POOL_BUF < 1)
#error "CH57xNET_NUM_POOL_BUF Error,Please Config CH57xNET_NUM_POOL_BUF >= 1"
#endif
/* PBUFṹ */
#if(CH57xNET_NUM_PBUF < 1)
#error "CH57xNET_NUM_PBUF Error,Please Config CH57xNET_NUM_PBUF >= 1"
#endif
/* IP */
#if((CH57xNET_NUM_IP_REASSDATA > 10)||(CH57xNET_NUM_IP_REASSDATA < 1))
#error "CH57xNET_NUM_IP_REASSDATA Error,Please Config CH57xNET_NUM_IP_REASSDATA < 10 && CH57xNET_NUM_IP_REASSDATA >= 1 "
#endif
/* IPƬС */
#if(CH57xNET_IP_REASS_PBUFS > CH57xNET_NUM_POOL_BUF)
#error "CH57xNET_IP_REASS_PBUFS Error,Please Config CH57xNET_IP_REASS_PBUFS < CH57xNET_NUM_POOL_BUF"
#endif



/* ڲ */

UINT8 CH57xNET_Init(const UINT8* ip,const UINT8* gwip,const UINT8* mask,const UINT8* macaddr); /* ʼ */

UINT8 CH57xNET_GetVer(void);                                                    /* ѯİ汾 */
UINT8 CH57xNET_ConfigLIB(struct _CH57x_CFG *cfg);                               /* ÿ*/
                                                                                
void  CH57xNET_MainTask(void);                                                  /* Ҫһֱϵ */
                                                                                
void CH57xNET_TimeIsr(UINT16 timperiod);                                        /* ʱжϷǰʱ */
                                                                                
void CH57xNET_ETHIsr(void);                                                     /* CH57xETHжϷ */ 
                                                                                
UINT8 CH57xNET_GetPHYStatus(void);                                              /* ȡPHY״̬ */
                                                                                
UINT8 CH57xNET_QueryGlobalInt(void);                                             /* ѯȫж */
                                                                                
UINT8 CH57xNET_GetGlobalInt (void);                                             /* ȫжϲȫж */
                                                                                
void CH57xNET_OpenMac(void);                                                    /* MAC */
                                                                                
void CH57xNET_CloseMac(void);                                                   /* رMAC */
                                                                                
UINT8 CH57xNET_SocketCreat(UINT8 *socketid,SOCK_INF *socinf);                   /* socket */
                                                                                
UINT8 CH57xNET_SocketSend(UINT8 socketid,UINT8 *buf,UINT32 *len);               /* Socket */
                                                                                
UINT8 CH57xNET_SocketRecv(UINT8 socketid,UINT8 *buf,UINT32 *len);               /* Socket */
                                                                                
UINT8 CH57xNET_GetSocketInt(UINT8 sockedid);                                    /* ȡsocketжϲ */
                                                                                
UINT32 CH57xNET_SocketRecvLen(UINT8 socketid,UINT32 *bufaddr);                  /* ȡsocketճ */
                                                                                
UINT8 CH57xNET_SocketConnect(UINT8 socketid);                                   /* TCP*/
                                                                                
UINT8 CH57xNET_SocketListen(UINT8 socindex);                                    /* TCP */
                                                                                
UINT8 CH57xNET_SocketClose(UINT8 socindex,UINT8 flag);                          /* ر */

void CH57xNET_ModifyRecvBuf(UINT8 sockeid,UINT32 bufaddr,UINT32 bufsize);       /* ޸Ľջ */

UINT8 CH57xNET_SocketUdpSendTo(UINT8 socketid, UINT8 *buf, UINT32 *slen,UINT8 *sip,UINT16 port);/* ָĿIP˿ڷUDP */

UINT8 CH57xNET_Aton(const UINT8 *cp, UINT8 *addr);                              /* ASCIIַתַ */
                                                                                
UINT8 *CH57xNET_Ntoa(UINT8 *ipaddr);                                            /* ַתASCIIַ */
                                                                                
UINT8 CH57xNET_SetSocketTTL(UINT8 socketid, UINT8 ttl);                         /* socketTTL */
                                                                                
void CH57xNET_RetrySendUnack(UINT8 socketid);                                   /* TCPش */

UINT8 CH57xNET_QueryUnack(SOCK_INF  *sockinf,UINT32 *addrlist,UINT16 lislen)    /* ѯδͳɹݰ */;

UINT8 CH57xNET_DHCPStart(UINT8(* usercall)(UINT8 status,void *));               /* DHCP */
                                                                                
UINT8 CH57xNET_DHCPStop(void);                                                  /* DHCPֹͣ */

void CH57xNET_InitDNS(UINT8 *dnsip,UINT16 port);                                /* DNSʼ */

UINT8 CH57xNET_GetHostName(const char *hostname,UINT8 *addr,dns_callback found,void *arg);/* DNSȡ */

void CH57xNET_ConfigKeepLive(struct _KEEP_CFG *cfg);                            /* ÿKEEP LIVE */

UINT8 CH57xNET_SocketSetKeepLive(UINT8 socindex,UINT8 cfg);                     /* socket KEEP LIVE*/

void CH57xNET_SetHostname(char *name);

#ifdef __cplusplus
}
#endif
#endif


